use actix_web::{get, post, web::Json, App, HttpResponse, HttpServer, Responder};

use serde::Deserialize;
mod auth_middleware;

#[derive(Deserialize)]
struct Data {
    demo: String,
}

#[get("/")]
async fn index() -> impl Responder {
    HttpResponse::Ok().body("Actix is alive!")
}

#[post("/")]
async fn postfunction(json: Json<Data>) -> impl Responder {
    HttpResponse::Ok().body(json.demo.clone())
}

#[actix_web::main] // Same as #[tokio::main]
async fn main() -> std::io::Result<()> {
    println!("Serving at http://localhost:8080");
    HttpServer::new(|| {
        App::new()
            .wrap(auth_middleware::AuthenticateMiddlewareFactory::new(
                auth_middleware::AuthData,
            ))
            .service(index)
            .service(postfunction)
    })
    .bind("0.0.0.0:8080")
    .unwrap()
    .run()
    .await
}
